diff --git a/libgui/src/variable-editor.cc b/libgui/src/variable-editor.cc
--- a/libgui/src/variable-editor.cc
+++ b/libgui/src/variable-editor.cc
@@ -703,759 +1209,88 @@ variable_editor::closeEvent (QCloseEvent
 }
 
 void
-variable_editor::closeTab (int idx)
+variable_editor::variable_destroyed (QObject *)
 {
-  if (idx < 0 || idx > m_tab_widget->count ())
-    return;
-
-  QWidget *wdgt = m_tab_widget->widget (idx);
-
-  m_tab_widget->removeTab (idx);
-
-  delete wdgt;
-
-  enable_actions ();
+  QList<variable_dock_widget *> vdwlist = findChildren<variable_dock_widget *> ();
+  if (vdwlist.isEmpty ())
+    m_tool_bar->setEnabled (false);
 }
 
 void
-variable_editor::contextmenu_requested (const QPoint& qpos)
+variable_editor::variable_focused (const QString &name)
 {
-  QTableView *view = m_tab_widget->get_edit_view ();
-
-  if (! view)
-    return;
-
-  QModelIndex index = view->indexAt (qpos);
-
-  if (index.isValid ())
-    {
-      QMenu *menu = new QMenu (this);
-
-      menu->addAction (resource_manager::icon ("edit-cut"),
-                       tr ("Cut"), this, SLOT (cutClipboard ()));
-
-      menu->addAction (resource_manager::icon ("edit-copy"),
-                       tr ("Copy"), this, SLOT (copyClipboard ()));
-
-      menu->addAction (resource_manager::icon ("edit-paste"),
-                       tr ("Paste"), this, SLOT (pasteClipboard ()));
-
-      // FIXME: Need different icon for paste table separate from paste?
-
-      menu->addAction (resource_manager::icon ("edit-paste"),
-                       tr ("Paste Table"), this,
-                       SLOT (pasteTableClipboard ()));
-
-      menu->addSeparator ();
-
-      menu->addAction (resource_manager::icon ("edit-delete"),
-                       tr ("Clear"), this, SLOT (clearContent ()));
-
-      menu->addAction (resource_manager::icon ("document-new"),
-                       tr ("Variable from Selection"), this,
-                       SLOT (createVariable ()));
-
-      // FIXME: addAction for sort?
-      // FIXME: Add icon for transpose.
-
-      menu->addAction (tr ("Transpose"), this, SLOT (transposeContent ()));
-
-      QItemSelectionModel *sel = view->selectionModel ();
-
-      QList<QModelIndex> indices = sel->selectedIndexes ();
-
-      if (! indices.isEmpty ())
-        {
-          menu->addSeparator ();
-
-          QSignalMapper *plot_mapper = new QSignalMapper (menu);
-
-          plot_mapper->setMapping
-            (menu->addAction ("plot", plot_mapper, SLOT (map ())),
-             "figure (); plot (%1);");
-
-          plot_mapper->setMapping
-            (menu->addAction ("bar", plot_mapper, SLOT (map ())),
-             "figure (); bar (%1);");
-
-          plot_mapper->setMapping
-            (menu->addAction ("stem", plot_mapper, SLOT (map ())),
-             "figure (); stem (%1);");
-
-          plot_mapper->setMapping
-            (menu->addAction ("stairs", plot_mapper, SLOT (map ())),
-             "figure (); stairs (%1);");
-
-          plot_mapper->setMapping
-            (menu->addAction ("area", plot_mapper, SLOT (map ())),
-             "figure (); area (%1);");
-
-          plot_mapper->setMapping
-            (menu->addAction ("pie", plot_mapper, SLOT (map ())),
-             "figure (); pie (%1);");
-
-          plot_mapper->setMapping
-            (menu->addAction ("hist", plot_mapper, SLOT (map ())),
-             "figure (); hist (%1);");
-
-          connect (plot_mapper, SIGNAL (mapped (const QString&)),
-                   this, SLOT (relay_command (const QString&)));
-        }
-
-      menu->exec (view->mapToGlobal (qpos));
-    }
+  m_current_focus_vname = name;
 }
 
 void
-variable_editor::columnmenu_requested (const QPoint& pt)
+variable_editor::record_hovered_focus_variable (void)
 {
-  QTableView *view = m_tab_widget->get_edit_view ();
-
-  if (! view)
-    return;
-
-  int index = view->horizontalHeader ()->logicalIndexAt (pt);
-
-  if (index < 0 || index > view->model ()->columnCount ())
-    return;
-
-  QString selection = selected_to_octave ();
-
-  QList<int> coords = octave_to_coords (selection);
-
-  bool nothingSelected = coords.isEmpty ();
-
-  bool whole_columns_selected
-    =  (nothingSelected
-        ? false
-        : (coords[0] == 1 && coords[1] == view->model ()->rowCount ()));
-
-  bool current_column_selected
-    = nothingSelected ? false : (coords[2] <= index+1 && coords[3] > index);
-
-  int column_selection_count
-    = nothingSelected ? 0 : (coords[3] - coords[2] + 1);
-
-  if (! whole_columns_selected || ! current_column_selected)
-    {
-      view->selectColumn (index);
-      column_selection_count = 1;
-      current_column_selected = true;
-      whole_columns_selected = true;
-    }
-
-  QString column_string
-    = tr (column_selection_count > 1 ? " columns" : " column");
-
-  QMenu *menu = new QMenu (this);
-
-  menu->addAction (resource_manager::icon ("edit-cut"),
-                   tr ("Cut") + column_string,
-                   this, SLOT (cutClipboard ()));
-
-  menu->addAction (resource_manager::icon ("edit-copy"),
-                   tr ("Copy") + column_string,
-                   this, SLOT (copyClipboard ()));
-
-  menu->addAction (resource_manager::icon ("edit-paste"),
-                   tr ("Paste"),
-                   this, SLOT (pasteClipboard ()));
-
-  // FIXME: Different icon for Paste Table?
-
-  menu->addAction (resource_manager::icon ("edit-paste"),
-                   tr ("Paste Table"),
-                   this, SLOT (pasteTableClipboard ()));
-
-  menu->addSeparator ();
-
-  menu->addAction (resource_manager::icon ("edit-delete"),
-                   tr ("Clear") + column_string,
-                   this, SLOT (clearContent ()));
-
-  menu->addAction (resource_manager::icon ("edit-delete"),
-                   tr ("Delete") + column_string,
-                   this, SLOT (delete_selected ()));
-
-  menu->addAction (resource_manager::icon ("document-new"),
-                   tr ("Variable from Selection"),
-                   this, SLOT (createVariable ()));
-
-  menu->addSeparator ();
-
-  QSignalMapper *plot_mapper = new QSignalMapper (menu);
-
-  plot_mapper->setMapping
-    (menu->addAction ("plot", plot_mapper, SLOT (map ())),
-     "figure (); plot (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("bar", plot_mapper, SLOT (map ())),
-     "figure (); bar (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("stem", plot_mapper, SLOT (map ())),
-     "figure (); stem (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("stairs", plot_mapper, SLOT (map ())),
-     "figure (); stairs (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("area", plot_mapper, SLOT (map ())),
-     "figure (); area (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("pie", plot_mapper, SLOT (map ())),
-     "figure (); pie (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("hist", plot_mapper, SLOT (map ())),
-     "figure (); hist (%1);");
-
-  connect (plot_mapper, SIGNAL (mapped (const QString&)),
-           this, SLOT (relay_command (const QString&)));
-
-  QPoint menupos = pt;
-  menupos.setY (view->horizontalHeader ()->height ());
-
-  menu->exec (view->mapToGlobal (menupos));
+  m_hovered_focus_vname = m_current_focus_vname;
 }
 
 void
-variable_editor::rowmenu_requested (const QPoint& pt)
+variable_editor::restore_hovered_focus_variable (void)
 {
-  QTableView *view = m_tab_widget->get_edit_view ();
-
-  if (! view)
-    return;
-
-  int index = view->verticalHeader ()->logicalIndexAt (pt);
-
-  if (index < 0 || index > view->model ()->columnCount ())
-    return;
-
-  QString selection = selected_to_octave ();
-
-  QList<int> coords = octave_to_coords (selection);
-
-  bool nothingSelected = coords.isEmpty ();
-
-  bool whole_rows_selected
-    = (nothingSelected
-       ? false
-       : (coords[2] == 1 && coords[3] == view->model ()->columnCount ()));
-
-  bool current_row_selected
-    = (nothingSelected ? false : (coords[0] <= index+1 && coords[1] > index));
-
-  int rowselection_count = nothingSelected ? 0 : (coords[3] - coords[2] + 1);
-
-  if (! whole_rows_selected || ! current_row_selected)
+  variable_dock_widget *tofocus = findChild<variable_dock_widget *> (m_hovered_focus_vname);
+  if (tofocus != nullptr)
     {
-      view->selectRow (index);
-      rowselection_count = 1;
-      current_row_selected = true;
-      whole_rows_selected = true;
+      // Note that this may be platform and window system dependent.
+      // On a particular Linux system, activateWindow() alone didn't
+      // immediately set the active window and there was a race
+      // between the window focus and action signal.  Setting the
+      // active window via the QApplication route did work.
+      QApplication::setActiveWindow(tofocus->window());
+      tofocus->activateWindow ();
+      tofocus->setFocus (Qt::OtherFocusReason);
     }
-
-  QString row_string = tr (rowselection_count > 1 ? " rows" : " row");
-
-  QMenu *menu = new QMenu (this);
-
-  menu->addAction (resource_manager::icon ("edit-cut"),
-                   tr ("Cut") + row_string,
-                   this, SLOT (cutClipboard ()));
-
-  menu->addAction (resource_manager::icon ("edit-copy"),
-                   tr ("Copy") + row_string,
-                   this, SLOT (copyClipboard ()));
-
-  menu->addAction (resource_manager::icon ("edit-paste"),
-                   tr ("Paste"),
-                   this, SLOT (pasteClipboard ()));
-
-  // FIXME: Better icon for Paste Table?
-
-  menu->addAction (resource_manager::icon ("edit-paste"),
-                   tr ("Paste Table"),
-                   this, SLOT (pasteTableClipboard ()));
-
-  menu->addSeparator ();
-
-  menu->addAction (resource_manager::icon ("edit-delete"),
-                   tr ("Clear") + row_string,
-                   this, SLOT (clearContent ()));
-
-  menu->addAction (resource_manager::icon ("edit-delete"),
-                   tr ("Delete") + row_string,
-                   this, SLOT (delete_selected ()));
-
-  menu->addAction (resource_manager::icon ("document-new"),
-                   tr ("Variable from Selection"),
-                   this, SLOT (createVariable ()));
-
-  menu->addSeparator ();
-
-  QSignalMapper *plot_mapper = new QSignalMapper (menu);
-
-  plot_mapper->setMapping
-    (menu->addAction ("plot", plot_mapper, SLOT (map ())),
-     "figure (); plot (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("bar", plot_mapper, SLOT (map ())),
-     "figure (); bar (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("stem", plot_mapper, SLOT (map ())),
-     "figure (); stem (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("stairs", plot_mapper, SLOT (map ())),
-     "figure (); stairs (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("area", plot_mapper, SLOT (map ())),
-     "figure (); area (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("pie", plot_mapper, SLOT (map ())),
-     "figure (); pie (%1);");
-
-  plot_mapper->setMapping
-    (menu->addAction ("hist", plot_mapper, SLOT (map ())),
-     "figure (); hist (%1);");
-
-  connect (plot_mapper, SIGNAL (mapped (const QString&)),
-           this, SLOT (relay_command (const QString&)));
-
-  QPoint menupos = pt;
-  menupos.setX (view->verticalHeader ()->width ());
-
-  // FIXME: What was the intent here?
-  // setY (view->verticalHeader ()->sectionPosition (index+1) +
-  //             view->verticalHeader ()->sectionSize (index));
-
-  menu->exec (view->mapToGlobal (menupos));
-}
-
-void
-variable_editor::double_click (const QModelIndex& idx)
-{
-  QString name = real_var_name (m_tab_widget->currentIndex ());
-
-  QTableView *table = m_tab_widget->get_edit_view ();
-
-  if (! table)
-    return;
-
-  variable_editor_model *model
-    = qobject_cast<variable_editor_model *> (table->model ());
-
-  if (model->requires_sub_editor (idx))
-    edit_variable (name + model->subscript_expression (idx),
-                   model->value_at (idx));
 }
 
 void
 variable_editor::save (void)
 {
-  QString name = real_var_name (m_tab_widget->currentIndex ());
-  QString file
-    = QFileDialog::getSaveFileName (this,
-                                    tr ("Save Variable %1 As").arg (name),
-                                    ".", 0, 0,
-                                    QFileDialog::DontUseNativeDialog);
-
-  // FIXME: Type? binary, float-binary, ascii, text, hdf5, matlab format?
-  // FIXME: Call octave_value::save_* directly?
-
-  if (! file.isEmpty ())
-    emit command_requested (QString ("save (\"%1\", \"%2\");")
-                            .arg (file)
-                            .arg (name));
-}
-
-void
-variable_editor::clearContent (void)
-{
-  // FIXME: Shift?
-
-  QTableView *view = m_tab_widget->get_edit_view ();
-
-  if (! view)
-    return;
-
-  QAbstractItemModel *model = view->model ();
-  QItemSelectionModel *sel = view->selectionModel ();
-  QList<QModelIndex> indices = sel->selectedIndexes ();
-
-  // FIXME: Use [] for empty cells?
-
-  for (const auto& idx : indices)
-    qobject_cast<variable_editor_model *> (model)->clear_content (idx);
+  emit save_signal ();
 }
 
 void
 variable_editor::cutClipboard (void)
 {
-  if (! has_focus ())
-    return;
-
   copyClipboard ();
 
-  clearContent ();
+  emit clear_content_signal ();
 }
 
 void
 variable_editor::copyClipboard (void)
 {
-  if (! has_focus ())
-    return;
-
-  QTableView *view = m_tab_widget->get_edit_view ();
-
-  if (! view)
-    return;
-
-  QAbstractItemModel *model = view->model ();
-  QItemSelectionModel *sel = view->selectionModel ();
-  QList<QModelIndex> indices = sel->selectedIndexes ();
-  qSort (indices);
-  if (indices.isEmpty ())
-    return;
-
-  // Convert selected items into TSV format and copy that.
-  // Spreadsheet tools should understand that.
-
-  QModelIndex previous = indices.first ();
-  QString copy = model->data (previous).toString ();
-  indices.removeFirst ();
-  foreach (QModelIndex idx, indices)
-    {
-      copy.push_back (previous.row () != idx.row () ? '\n' : '\t');
-      copy.append (model->data (idx).toString ());
-      previous = idx;
-    }
-  copy.push_back ('\n');
-
-  QClipboard *clipboard = QApplication::clipboard ();
-  clipboard->setText (copy);
+  emit copy_clipboard_signal ();
 }
 
 void
 variable_editor::pasteClipboard (void)
 {
-  if (! has_focus ())
-    return;
-
-  QClipboard *clipboard = QApplication::clipboard ();
-  QString text = clipboard->text ();
-
-  QTableView *view = m_tab_widget->get_edit_view ();
-
-  if (! view)
-    return;
-
-  QItemSelectionModel *sel = view->selectionModel ();
-  QList<QModelIndex> indices = sel->selectedIndexes ();
-
-  variable_editor_model *model
-    = static_cast<variable_editor_model *> (view->model ());
-
-  if (indices.isEmpty ())
-    {
-      if (view->size () == QSize (1,1))
-        model->setData (view->model ()->index (0,0), text.toDouble ());
-      else if (view->size () == QSize (0,0))
-        {
-          model->insertColumn (0);
-          model->insertRow (0);
-          model->setData (view->model ()->index (0,0), text.toDouble ());
-        }
-    }
-  else
-    {
-      for (int i = 0; i < indices.size (); i++)
-        view->model ()->setData (indices[i], text.toDouble ());
-    }
-
-  emit updated ();
-}
-
-void variable_editor::pasteTableClipboard (void)
-{
-  if (! has_focus ())
-    return;
-
-  QClipboard *clipboard = QApplication::clipboard ();
-  QString text = clipboard->text ();
-
-  QTableView *view = m_tab_widget->get_edit_view ();
-
-  if (! view)
-    return;
-
-  QItemSelectionModel *sel = view->selectionModel ();
-  QList<QModelIndex> indices = sel->selectedIndexes ();
-
-  variable_editor_model *model
-    = static_cast<variable_editor_model *> (view->model ());
-
-  QPoint start, end;
-
-  QPoint tabsize = QPoint (model->rowCount (), model->columnCount ());
-
-  if (indices.isEmpty ())
-    {
-      start = QPoint (0,0);
-      end = tabsize;
-    }
-  else if (indices.size () == 1)
-    {
-      start = QPoint (indices[0].row (), indices[0].column ());
-      end = tabsize;
-    }
-  else
-    {
-      end = QPoint (0,0);
-      start = tabsize;
-
-      for (int i = 0; i < indices.size (); i++)
-        {
-          if (indices[i].column () < start.y ())
-            start.setY (indices[i].column ());
-
-          if (indices[i].column () > end.y ())
-            end.setY (indices[i].column ());
-
-          if (indices[i].row () < start.x ())
-            start.setX (indices[i].column ());
-
-          if (indices[i].row () > end.x ())
-            end.setX (indices[i].column ());
-        }
-    }
-
-  int rownum = 0;
-  int colnum = 0;
-
-  QStringList rows = text.split ('\n');
-  for (const auto& row : rows)
-    {
-      if (rownum > end.x () - start.x ())
-        continue;
-
-      QStringList cols = row.split ('\t');
-      if (cols.isEmpty ())
-        continue;
-
-      for (const auto& col : cols)
-        {
-          if (col.isEmpty ())
-            continue;
-          if (colnum > end.y () - start.y () )
-            continue;
-
-          model->setData (model->index (rownum + start.x (),
-                                        colnum + start.y ()),
-                          QVariant (col));
-
-          colnum++;
-        }
-
-      colnum = 0;
-      rownum++;
-    }
+  emit paste_clipboard_signal ();
 
   emit updated ();
 }
 
 void
-variable_editor::createVariable (void)
+variable_editor::pasteTableClipboard (void)
 {
-  // FIXME: Create unnamed1..n if exist ('unnamed', 'var') is true.
-
-  relay_command ("unnamed = %1");
-}
-
-void
-variable_editor::transposeContent (void)
-{
-  QString name = real_var_name (m_tab_widget->currentIndex ());
-
-  emit command_requested (QString ("%1 = %1';").arg (name));
+  emit paste_table_clipboard_signal ();
 
   emit updated ();
 }
 
 void
-variable_editor::up (void)
+variable_editor::levelUp (void)
 {
-  QString name = real_var_name (m_tab_widget->currentIndex ());
-
-  // FIXME: Is there a better way?
-
-  if (name.endsWith (')') || name.endsWith ('}'))
-    {
-      name.remove (QRegExp ("(\\(|\\{)[^({]*(\\)|\\})$"));
-      edit_variable (name, octave_value ());
-    }
+  emit level_up_signal ();
 }
 
 void
-variable_editor::delete_selected (void)
+variable_editor::relay_selected_command (const QString& cmd)
 {
-  QTableView *view = m_tab_widget->get_edit_view ();
-
-  if (! view)
-    return;
-
-  QString selection = selected_to_octave ();
-  QList<int> coords = octave_to_coords (selection);
-
-  if (coords.isEmpty ())
-    return;
-
-  bool whole_columns_selected
-    = coords[0] == 1 && coords[1] == view->model ()->rowCount ();
-
-  bool whole_rows_selected
-    = coords[2] == 1 && coords[3] == view->model ()->columnCount ();
-
-  // Must be deleting whole columns or whole rows, and not the whole thing.
-
-  if (whole_columns_selected == whole_rows_selected)
-    return;
-
-  if (whole_rows_selected)
-    view->model ()->removeRows (coords[0], coords[1] - coords[0]);
-
-  if (whole_columns_selected)
-    view->model ()->removeColumns (coords[2], coords[3] - coords[2]);
-
-  emit updated ();
-}
-
-void
-variable_editor::relay_command (const QString& cmd)
-{
-  emit command_requested (cmd.arg (selected_to_octave ()));
-}
-
-QList<int>
-variable_editor::octave_to_coords (QString& selection)
-{
-  // FIXME: Is this necessary or would it be quicker to clone the function
-  // that gives us the QString?
-
-  // Sanity check.
-
-  if (selection.count (",") != 1)
-    return QList<int> ();
-
-  // FIXME: Why clear if object has just been created?
-
-  QList<int> output;
-  output.clear ();
-
-  // Remove braces.
-
-  int firstbracket = std::max (selection.indexOf ("("),
-                               selection.indexOf ("{"));
-
-  selection = selection.mid (firstbracket + 1,
-                             selection.length () - (firstbracket + 2));
-
-  QString rows = selection.left (selection.indexOf (","));
-  if (! rows.contains (":"))
-    {
-      // Only one row.
-
-      output.push_back (rows.toInt ());
-      output.push_back (output.last ());
-    }
-  else
-    {
-      output.push_back (rows.left (rows.indexOf (":")).toInt ());
-      output.push_back (rows.right (rows.length () - (rows.indexOf (":") + 1))
-                        .toInt ());
-    }
-
-  QString cols;
-  cols = selection.right (selection.length () - (selection.indexOf (",") + 1));
-  if (cols.left (1) == " ")
-    cols = cols.right (cols.length () - 1);
-
-  if (! cols.contains (":"))
-    {
-      // Only one row.
-
-      output.push_back (cols.toInt ());
-      output.push_back (output.last ());
-    }
-  else
-    {
-      output.push_back (cols.left (cols.indexOf (":")).toInt ());
-      output.push_back (cols.right (cols.length () - (cols.indexOf (":") + 1))
-                        .toInt ());
-    }
-
-  return output;
-}
-
-// Return the real variable name from the tab addressed by 'index',
-// cleaned of any '&' possibly inserted by KDE.
-
-QString
-variable_editor::real_var_name (int index)
-{
-  QString var_name = m_tab_widget->tabText (index);
-  var_name.remove (QChar ('&'));
-  return var_name;
-}
-
-QString
-variable_editor::selected_to_octave (void)
-{
-  QString name = real_var_name (m_tab_widget->currentIndex ());
-
-  QTableView *view = m_tab_widget->get_edit_view ();
-
-  if (! view)
-    return name;
-
-  QItemSelectionModel *sel = view->selectionModel ();
-
-  // Return early if nothing selected.
-
-  if (! sel->hasSelection ())
-    return name;
-
-  QList<QModelIndex> indices = sel->selectedIndexes ();
-
-  // FIXME: Shouldn't this be keyed to octave_idx_type?
-
-  int32_t from_row = std::numeric_limits<int32_t>::max ();
-  int32_t to_row = 0;
-  int32_t from_col = std::numeric_limits<int32_t>::max ();
-  int32_t to_col = 0;
-
-  for (const auto& idx : indices)
-    {
-      from_row = std::min (from_row, idx.row ());
-      to_row = std::max (to_row, idx.row ());
-      from_col = std::min (from_col, idx.column ());
-      to_col = std::max (to_col, idx.column ());
-    }
-
-  QString rows = idx_to_expr (from_row, to_row);
-  QString cols = idx_to_expr (from_col, to_col);
-
-  // FIXME: Does cell need separate handling?  Maybe use '{.,.}'?
-
-  return QString ("%1(%2, %3)").arg (name).arg (rows).arg (cols);
+  emit selected_command_signal (cmd);
 }
 
 // Also updates the font.
@@ -1491,12 +1326,10 @@ void variable_editor::update_colors (voi
         + m_table_colors[3].name () +" }";
     }
 
-  if (m_tab_widget->count () < 1)
-    return;
-
-  for (int i = 0; i < m_tab_widget->count (); i++)
+  QList<QTableView *> viewlist = findChildren<QTableView *> ();
+  for (int i = 0; i < viewlist.size (); i++)
     {
-      QTableView *view = m_tab_widget->get_edit_view ();
+      QTableView *view = viewlist.at (i);
 
       if (! view)
         continue;
@@ -1508,36 +1341,59 @@ void variable_editor::update_colors (voi
 
 }
 
+QAction *
+variable_editor::add_tool_bar_button (const QIcon &icon,
+                                      const QString &text,
+                                      const QObject *receiver,
+                                      const char *member)
+{
+  QAction *action = new QAction (icon, text, this);
+  connect(action, SIGNAL (triggered ()), receiver, member);
+  QToolButton *button = new ReturnFocusToolButton (m_tool_bar);
+  button->setDefaultAction (action);
+  button->setText (text);
+  button->setToolTip (text);
+  button->setIcon (icon);
+  m_tool_bar->addWidget (button);
+
+  return action;
+}
+
 void
 variable_editor::construct_tool_bar (void)
 {
   m_tool_bar->setAllowedAreas (Qt::TopToolBarArea);
 
-  m_tool_bar->setMovable (false);
-
   m_tool_bar->setObjectName ("VariableEditorToolBar");
 
   m_tool_bar->setWindowTitle (tr ("Variable Editor Toolbar"));
 
-  m_tool_bar->addAction (resource_manager::icon ("document-save"),
-                         tr ("Save"), this, SLOT (save ()));
+  QAction *action;
+  action = add_tool_bar_button (resource_manager::icon ("document-save"),
+                                tr ("Save"), this, SLOT (save ()));
+  action->setShortcuts (QKeySequence::Save);
+  action->setStatusTip(tr("Save variable to a file"));
 
   m_tool_bar->addSeparator ();
 
-  m_tool_bar->addAction (resource_manager::icon ("edit-cut"),
-                         tr ("Cut"), this, SLOT (cutClipboard ()));
+  action = add_tool_bar_button (resource_manager::icon ("edit-cut"),
+                                tr ("Cut"), this, SLOT (cutClipboard ()));
+  action->setStatusTip(tr("Cut data to clipboard"));
 
-  m_tool_bar->addAction (resource_manager::icon ("edit-copy"),
-                         tr ("Copy"), this, SLOT (copyClipboard ()));
+  action = add_tool_bar_button (resource_manager::icon ("edit-copy"),
+                                tr ("Copy"), this, SLOT (copyClipboard ()));
+  action->setStatusTip(tr("Copy data to clipboard"));
 
-  m_tool_bar->addAction (resource_manager::icon ("edit-paste"),
-                         tr ("Paste"), this, SLOT (pasteClipboard ()));
+  action = add_tool_bar_button (resource_manager::icon ("edit-paste"),
+                                tr ("Paste"), this, SLOT (pasteClipboard ()));
+  action->setStatusTip(tr("Paste clipboard into variable data"));
 
   // FIXME: Different icon for Paste Table?
 
-  m_tool_bar->addAction (resource_manager::icon ("edit-paste"),
-                         tr ("Paste Table"),
-                         this, SLOT (pasteTableClipboard ()));
+  action = add_tool_bar_button (resource_manager::icon ("edit-paste"),
+                                tr ("Paste Table"),
+                                this, SLOT (pasteTableClipboard ()));
+  action->setStatusTip(tr("Another paste clipboard into variable data"));
 
   m_tool_bar->addSeparator ();
 
@@ -1545,50 +1401,26 @@ variable_editor::construct_tool_bar (voi
   // QAction *print_action; /icons/fileprint.png
   // m_tool_bar->addSeparator ();
 
-  QToolButton *plot_tool_button = new QToolButton (m_tool_bar);
+  action = new QAction (resource_manager::icon ("plot-xy-curve"),
+                        tr ("Plot"), m_tool_bar);
+  action->setToolTip (tr ("Plot Selected Data"));
+  QToolButton *plot_tool_button = new HoverToolButton (m_tool_bar);
+  plot_tool_button->setDefaultAction (action);
 
   plot_tool_button->setText (tr ("Plot"));
-  plot_tool_button->setToolTip (tr ("Plot Selected Data"));
+  plot_tool_button->setToolTip (tr ("Plot selected data"));
   plot_tool_button->setIcon (resource_manager::icon ("plot-xy-curve"));
 
   plot_tool_button->setPopupMode (QToolButton::InstantPopup);
 
-  QMenu *plot_menu = new QMenu (tr ("Plot"), plot_tool_button);
-
+  QMenu *plot_menu = new ReturnFocusMenu (plot_tool_button);
+  plot_menu->setTitle (tr ("Plot"));
   plot_menu->setSeparatorsCollapsible (false);
 
-  QSignalMapper *plot_mapper = new QSignalMapper (plot_menu);
-
-  plot_mapper->setMapping
-    (plot_menu->addAction ("plot", plot_mapper, SLOT (map ())),
-     "figure (); plot (%1);");
-
-  plot_mapper->setMapping
-    (plot_menu->addAction ("bar", plot_mapper, SLOT (map ())),
-     "figure (); bar (%1);");
-
-  plot_mapper->setMapping
-    (plot_menu->addAction ("stem", plot_mapper, SLOT (map ())),
-     "figure (); stem (%1);");
-
-  plot_mapper->setMapping
-    (plot_menu->addAction ("stairs", plot_mapper, SLOT (map ())),
-     "figure (); stairs (%1);");
-
-  plot_mapper->setMapping
-    (plot_menu->addAction ("area", plot_mapper, SLOT (map ())),
-     "figure (); area (%1);");
-
-  plot_mapper->setMapping
-    (plot_menu->addAction ("pie", plot_mapper, SLOT (map ())),
-     "figure (); pie (%1);");
-
-  plot_mapper->setMapping
-    (plot_menu->addAction ("hist", plot_mapper, SLOT (map ())),
-     "figure (); hist (%1);");
+  QSignalMapper *plot_mapper = make_plot_mapper (plot_menu);
 
   connect (plot_mapper, SIGNAL (mapped (const QString&)),
-           this, SLOT (relay_command (const QString&)));
+           this, SLOT (relay_selected_command (const QString&)));
 
   plot_tool_button->setMenu (plot_menu);
 
@@ -1596,8 +1428,41 @@ variable_editor::construct_tool_bar (voi
 
   m_tool_bar->addSeparator ();
 
-  m_tool_bar->addAction (QIcon (resource_manager::icon ("go-up")), tr ("Up"),
-                         this, SLOT (up ()));
+  action = add_tool_bar_button (resource_manager::icon ("go-up"),
+                                tr ("Up"), this, SLOT (levelUp ()));
+  action->setStatusTip(tr("Go one level up in variable hierarchy"));
+
+  // The QToolButton mouse-clicks change active window, so connect all
+  // HoverToolButton and RuternFocusToolButton objects to the mechanism
+  // that restores active window and focus before acting.
+  QList<HoverToolButton *> hbuttonlist = m_tool_bar->
+      findChildren<HoverToolButton *> (QString (), Qt::FindDirectChildrenOnly);
+  for (int i = 0; i < hbuttonlist.size (); i++)
+    {
+      connect (hbuttonlist.at (i), SIGNAL (hovered_signal ()),
+               this, SLOT (record_hovered_focus_variable ()));
+      connect (hbuttonlist.at (i), SIGNAL (popup_shown_signal ()),
+               this, SLOT (restore_hovered_focus_variable ()));
+    }
+  QList<ReturnFocusToolButton *> rfbuttonlist = m_tool_bar->
+      findChildren<ReturnFocusToolButton *> (QString (), Qt::FindDirectChildrenOnly);
+  for (int i = 0; i < rfbuttonlist.size (); i++)
+    {
+      connect (rfbuttonlist.at (i), SIGNAL (about_to_activate ()),
+               this, SLOT (restore_hovered_focus_variable ()));
+    }
+
+  // Same for QMenu
+  QList<ReturnFocusMenu *> menulist = m_tool_bar->
+      findChildren<ReturnFocusMenu *> (QString ());
+  for (int i = 0; i < menulist.size (); i++)
+    {
+      connect (menulist.at (i), SIGNAL (about_to_activate ()),
+               this, SLOT (restore_hovered_focus_variable ()));
+    }
+
+  m_tool_bar->setAttribute(Qt::WA_ShowWithoutActivating);
+  m_tool_bar->setFocusPolicy (Qt::NoFocus);
 
   // Disabled when no tab is present.
 
